﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace Aio1Ef.Packer.Common.Coders
{
    internal static class AssemblyInfoCoder
    {

        public static string GenerateResult(Assembly me)
        {
            var sb = new StringBuilder();


            foreach (var attr in me.GetCustomAttributes())
            {
                attr.ExtractAsmAttrVal<AssemblyTitleAttribute>(sb, p => p.Title);
                attr.ExtractAsmAttrVal<AssemblyDescriptionAttribute>(sb, p => p.Description);
                attr.ExtractAsmAttrVal<AssemblyConfigurationAttribute>(sb, p => p.Configuration);
                attr.ExtractAsmAttrVal<AssemblyCompanyAttribute>(sb, p => p.Company);
                attr.ExtractAsmAttrVal<AssemblyProductAttribute>(sb, p => p.Product);
                attr.ExtractAsmAttrVal<AssemblyCopyrightAttribute>(sb, p => p.Copyright);
                attr.ExtractAsmAttrVal<AssemblyTrademarkAttribute>(sb, p => p.Trademark);
                attr.ExtractAsmAttrVal<AssemblyCultureAttribute>(sb, p => p.Culture);
                attr.ExtractAsmAttrVal<ComVisibleAttribute>(sb, p => p.Value);
                attr.ExtractAsmAttrVal<GuidAttribute>(sb, p => p.Value);
                attr.ExtractAsmAttrVal<AssemblyVersionAttribute>(sb, p => p.Version);
                attr.ExtractAsmAttrVal<AssemblyFileVersionAttribute>(sb, p => p.Version);
                attr.ExtractAsmAttrVal<AssemblyInformationalVersionAttribute>(sb, p => p.InformationalVersion);
            }

            return sb.ToString();
        }

        private static void ExtractAsmAttrVal<T>(this Attribute me, StringBuilder sb, Func<T, object> selector) where T : Attribute
        {
            if (me.GetType() == typeof(T))
            {
                var v = selector((T)me);

                if (v is string)
                {
                    v = $"\"{v}\"";
                }

                if (v is bool)
                {
                    v = ((bool)v)
                        ? "true"
                        : "false";
                }

                sb.AppendFormat("[assembly: {0}({1})]", me.GetType().FullName, v);
            }
        }
    }
}