﻿using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Aio1Ef.Packer.Common.Coders
{
    internal class ConfigCoder
    {
        private static readonly Regex RegEnv = new Regex(@"_C\((.+?)\)", RegexOptions.Compiled);

        private readonly string _code;
        private readonly Dictionary<string, string> _dicParams = new Dictionary<string, string>();

        public ConfigCoder(string code)
        {
            _code = code;
        }

        public string this[string configName]
        {
            set { _dicParams[configName] = value; }
            get { return _dicParams[configName]; }
        }

        public string GenerateResult()
        {
            var code = _code;

            var result = RegEnv.Replace(code, Evaluator);

            return result;
        }

        private string Evaluator(Match r)
        {
            var key = r.Groups[1].Value;
            return _dicParams.ContainsKey(key)
             ? _dicParams[key]
             : "";
        }
    }
}