﻿using SevenZip;
using System;
using System.Reflection;

// ReSharper disable once CheckNamespace
namespace Loader
{
    static partial class Program
    {
        private static bool IsSevenZipSharpLzmaInit;

        private static void InitSevenZipSharpLzma()
        {
            AppDomain.CurrentDomain.AssemblyResolve += ResolveSevenZipSharpLzma;
            IsSevenZipSharpLzmaInit = true;
        }

        private static Assembly ResolveSevenZipSharpLzma(object sender, ResolveEventArgs args)
        {
            if (args.Name == "SevenZipSharp, Version=0.64.3890.29348, Culture=neutral, PublicKeyToken=20de82c62b055c88")
            {
                return Assembly.Load(_compressLibrary);
            }

            return null;
        }

        public static byte[] DecompressSevenZipSharpLzma(byte[] data)
        {
            if (IsSevenZipSharpLzmaInit == false)
                InitSevenZipSharpLzma();

            return LazyDecompressSevenZipSharpLzma(data);
        }

        private static byte[] LazyDecompressSevenZipSharpLzma(byte[] data)
        {
            return SevenZipExtractor.ExtractBytes(data);
        }

        public static byte[] CompressSevenZipSharpLzma(byte[] data)
        {
            if (IsSevenZipSharpLzmaInit == false)
                InitSevenZipSharpLzma();

            return LazyCompressSevenZipSharpLzma(data);
        }

        private static byte[] LazyCompressSevenZipSharpLzma(byte[] data)
        {
            return SevenZipCompressor.CompressBytes(data);
        }
    }
}